;;;
;;; banyan - banyan common library
;;;
;;;  Copyright(C) 2002-2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: banyan.scm,v 1.15 2003/02/21 13:17:29 shirok Exp $
;;;

(define-module banyan
  (use gauche.uvector)
  (use gauche.parameter)
  (use gauche.hook)
  (use util.list)
  (use srfi-1)
  (use srfi-2)
  (use srfi-10)
  (use gl)
  (use gl.glut)
  (export-all))
(select-module banyan)

(define-method show ((obj <top>)) #f)   ;fallback

(dynamic-load "banyan")

(autoload banyan.license <cc:license> part-license cc:license->rdf)

(require "banyan/init")
(require "banyan/util")
(require "banyan/meta")
(require "banyan/part")
(require "banyan/repository")
(require "banyan/transient")
(require "banyan/color")
(require "banyan/scene")
(require "banyan/transform")
(require "banyan/shape")
(require "banyan/material")
(require "banyan/shader")
(require "banyan/instance")
(require "banyan/connector")
(require "banyan/camera")
(require "banyan/light")
(require "banyan/sandbox")
(require "banyan/export")

(provide "banyan")
