;;;
;;; banyan/export - exporter framework
;;;
;;;  Copyright(C) 2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: export.scm,v 1.3 2003/02/19 12:24:44 shirok Exp $
;;;

(select-module banyan)

(autoload banyan.export.vrml export-to-vrml)

(define export-formats
  (make-parameter
   `((vrml "VRML" ("*.wrl") ,(lambda () export-to-vrml)))))

(define (list-export-formats)
  (map (cut take <> 3) (export-formats)))

(define (get-exporter key)
  (and-let* ((entry (assq key (export-formats))))
    ((cadddr entry))))

(provide "banyan/export")
