;;;
;;; banyan/gui/app-browser - browser main window
;;;
;;;  Copyright(C) 2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: app-browser.scm,v 1.4 2003/02/23 03:32:54 shirok Exp $
;;;

(define-module banyan.gui.app-browser
  (extend banyan.gui)
  (use gauche.uvector)
  (use gauche.sequence)
  (export <banyan-app-browser>))
(select-module banyan.gui.app-browser)

(define-glim-application-frame <banyan-app-browser> ()
  ()
  (:panes
   (menu       (glim-pulldown-menu (banyan-browser-main-menu)))
;   (repository (make <repository-display>))
;   (part       (make <part-display> :active? #t))
   (main-view  (make <viewport>
                 :menu (banyan-browser-main-menu)
                 :grid-mode #t))
   )
  (:layouts
   (default (glim-vertically ()
              menu
;              (glim-outlining (:style :out)
;                (glim-horizontally (:thickness 4 :spacing 4)
;                  mode-button
;                  (:expand repository)
;                  (:expand part)
;                 ))
              (:expand main-view))))
  )

(define-method initialize ((self <banyan-app-browser>) initargs)
  (next-method self
               (list* :name 'banyan-app-browser
                      :pretty-name "Banyan Browser"
                      initargs))
  (let1 menu (banyan-browser-main-menu)
    (main-menu-delete-cameras! menu)
    (for-each (cute main-menu-add-camera! menu <>)
              (cameras-of (current-scene))))
  )

(provide "banyan/gui/app-browser")
