;;;
;;; banyan/gui/app-composer - composer main window
;;;
;;;  Copyright(C) 2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: app-composer.scm,v 1.4 2003/01/19 14:06:49 shirok Exp $
;;;

(define-module banyan.gui.app-composer
  (extend banyan.gui)
  (use gauche.uvector)
  (use gauche.sequence)
  (export <banyan-app-composer>))
(select-module banyan.gui.app-composer)

(define-glim-application-frame <banyan-app-composer> ()
  ()
  (:panes
   (menu       (glim-pulldown-menu (banyan-composer-main-menu)))
   (repository (make <repository-display>))
   (part       (make <part-display> :active? #t))
   (shelf      (make <composer-shelf>))
   (main-view  (make <viewport> :menu (banyan-composer-main-menu)))
   )
  (:layouts
   (default (glim-vertically ()
              menu
              (glim-outlining (:style :out)
                (glim-horizontally (:thickness 4 :spacing 4)
                  (:expand repository)
                  (:expand part)
                  ))
              (:expand
               (glim-horizontally ()
                 shelf
                 (:expand main-view))))))
  )

(define-method initialize ((self <banyan-app-composer>) initargs)
  (next-method self
               (list* :name 'banyan-app-composer
                      :pretty-name "Banyan Composer"
                      initargs))
  (let1 menu (banyan-composer-main-menu)
    (main-menu-delete-cameras! menu)
    (for-each (cute main-menu-add-camera! menu <>)
              (cameras-of (current-scene))))
  )

(provide "banyan/gui/app-composer")
