;;;
;;; banyan/gui/nodechangeparts - node selection
;;;
;;;  Copyright(C) 2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: nodepartschanger.scm,v 1.1 2003/01/23 09:19:11 shirok Exp $
;;;

(define-module banyan.gui.nodepartschanger
  (extend banyan.gui)
  (export <node-change-parts-dialog>))
(select-module banyan.gui.nodepartschanger)

;;------------------------------------------------------------------
;; A dialog to change parts of selected instances.
;;

(define-glim-application-frame <node-change-parts-dialog> ()
  ()
  (:panes
   (with-shader (make <glim-toggle-button>
                  :label "Change Parts of Shader"
                  :value #t))
   (with-object (make <glim-toggle-button>
                  :label "Change Parts of Object"
                  :value #t))
   )
  (:layouts
   (default
     (glim-vertically (:spacing 2 :thickness 4)
       with-shader
       with-object
       (----)
       (dialog-buttons
        (dialog-action-gadget "OK" 'ok)
        (dialog-action-gadget "Close" 'close))
       )))
  )

(define-method initialize ((self <node-change-parts-dialog>) initargs)
  (next-method self
               (list* :name 'node-change-parts
                      :pretty-name "Node change parts"
                      initargs))
  )

;;------------------------------------------------------------------
;; Actions
;;

(define-method dialog-action ((self <node-change-parts-dialog>) action)
  (when (eq? action 'ok)
    (let* ((scene (current-scene))
           (selected (selections-of scene))
           (with-shader? (glim-gadget-value
                          (glim-get-frame-pane self 'with-shader)))
           (with-object? (glim-gadget-value
                          (glim-get-frame-pane self 'with-object)))
           )
      (for-each (cut instance-change-parts <> (current-part)
                     :with-shader with-shader?
                     :with-object with-object?)
                selected)
      ))
  (glim-frame-exit self))

(provide "banyan/gui/nodepartschanger")

