;;;
;;; banyan/gui/transfreezer - freeze transform dialog
;;;
;;;  Copyright(C) 2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: transfreezer.scm,v 1.2 2003/02/07 05:50:38 shirok Exp $
;;;

(define-module banyan.gui.transfreezer
  (extend banyan.gui)
  (export <transform-freeze-dialog>))
(select-module banyan.gui.transfreezer)

;;------------------------------------------------------------------
;; A dialog for "Freeze transform" operation
;;

(define-glim-application-frame <transform-freeze-dialog> ()
  ()
  (:panes
   (freeze-t (make <glim-toggle-button> :label "Freeze translation" :value #f))
   (freeze-r (make <glim-toggle-button> :label "Freeze rotation" :value #t))
   (freeze-s (make <glim-toggle-button> :label "Freeze scale" :value #t))
   )
  (:layouts
   (default
     (glim-vertically (:spacing 2 :thickness 4)
       freeze-t
       freeze-r
       freeze-s
       (----)
       (dialog-buttons
        (dialog-action-gadget "OK" 'ok)
        (dialog-action-gadget "Apply" 'apply)
        (dialog-action-gadget "Close" 'close))
       )))
  )

(define-method initialize ((self <transform-freeze-dialog>) initargs)
  (next-method self
               (list* :name 'transform-freeze
                      :pretty-name "Freeze transform"
                      initargs))
  )

;;------------------------------------------------------------------
;; Actions
;;

(define-method dialog-action ((self <transform-freeze-dialog>) action)
  (when (memq action '(ok apply))
    (for-each
     (cute freeze-transform! <>
           (cond-list
            ((glim-gadget-value (glim-get-frame-pane self 'freeze-t))
             'translation)
            ((glim-gadget-value (glim-get-frame-pane self 'freeze-r))
             'rotation)
            ((glim-gadget-value (glim-get-frame-pane self 'freeze-s))
             'scale)))
     (selections-of (current-scene))))
  (when (memq action '(ok close))
    (glim-frame-exit self)))

(provide "banyan/gui/transfreezer")

