;;;
;;; banyan.material - material parameters
;;;
;;;  Copyright(C) 2002-2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: material.scm,v 1.5 2003/01/01 00:59:50 shirok Exp $
;;;

(select-module banyan)

;; PROTOTYPE IMPLEMENTATION

;;---------------------------------------------------------------
;; Material
;;   A passive object that maintains parameters for shaders.

;; Abstract material class
(define-class <material> (<node>)
  ()
  :abstract #t)

;; GL material --------------------------------------------------
;;   standard OpenGL material, used by OpenGL shader.

(define-class <gl-material> (<material>)
  ((ambient   :init-keyword :ambient :accessor ambient-of
              :attribute-type <bn-color3>
              :initform (f32vector 0.2 0.2 0.2 1.0))
   (diffuse   :init-keyword :diffuse :accessor diffuse-of
              :attribute-type <bn-color3>
              :initform (f32vector 0.8 0.8 0.8 1.0))
   (specular  :init-keyword :specular :accessor specular-of
              :attribute-type <bn-color3>
              :initform (f32vector 0.0 0.0 0.0 1.0))
   (shininess :init-keyword :shininess :accessor shininess-of
              :attribute-type <real>
              :initform 0.0)
   (emission  :init-keyword :emission :accessor emission-of
              :attribute-type <bn-color3>
              :initform (f32vector 0.0 0.0 0.0 1.0))
   ))



(provide "banyan/material")
