;;;
;;; banyan.transient - transient node
;;;
;;;  Copyright(C) 2002-2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: transient.scm,v 1.4 2003/01/01 00:59:50 shirok Exp $
;;;

(select-module banyan)

;;----------------------------------------------------------------
;; Transient node
;;

;; Transient node is a node only exists in client scene.  It is
;; always created in the special part, so that it won't be saved
;; by the default operations.

(define transient-part
  (let1 tp (make <part> :name "*Transient*" :repository #f)
    (lambda () tp)))

(define-class <transient-node> (<node>)
  ())

(define-method initialize ((self <transient-node>) initargs)
  (with-part (transient-part) (next-method)))

(provide "banyan/transient")
