;;;
;;; glim/pane/button.scm - glim-*-button panes, to be autoloaded.
;;;
;;;  Copyright(C) 2002-2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: button.scm,v 1.4 2003/01/01 01:04:00 shirok Exp $
;;;

(select-module glim.pane)

;;---------------------------------------------------
;; <glim-push-button>
;;

(define-class <glim-push-button> (<glim-gtk-mixin>
                                  <glim-labelled-gadget-mixin>
                                  <glim-action-gadget>
                                  <gtk-button>)
  ((label :allocation :virtual
          :init-keyword :label
          :slot-ref  (lambda (o)
                       (ref o 'label-text))
          :slot-set! (lambda (o v)
                       (gtk-button-set-label o (x->string v))))
   ))

(define-method initialize ((self <glim-push-button>) initargs)
  (next-method)
  (g-signal-connect self "clicked" glim-activate-callback))

;;---------------------------------------------------
;; <glim-toggle-button>
;;   uses gtk-check-button

(define-class <glim-toggle-button> (<glim-gtk-mixin>
                                    <glim-labelled-gadget-mixin>
                                    <glim-value-gadget>
                                    <gtk-check-button>)
  ((widget :allocation :virtual :slot-ref  identity :slot-set! list)
   (label :allocation :virtual
          :init-keyword :label
          :slot-ref  (lambda (o)
                       (ref o 'label-text))
          :slot-set! (lambda (o v)
                       (gtk-button-set-label o (x->string v))))
   (value :allocation :virtual
          :init-keyword :value
          :slot-ref  (lambda (o)
                       (gtk-toggle-button-get-active o))
          :slot-set! (lambda (o v)
                       (gtk-toggle-button-set-active o v)))
   ))

(define-method initialize ((self <glim-toggle-button>) initargs)
  (next-method)
  (g-signal-connect self "toggled"
                    (lambda (w)
                      (glim-value-changed-callback
                       w
                       (gtk-toggle-button-get-active w)))))

(define-method glim-gadget-value ((self <glim-toggle-button>))
  (gtk-toggle-button-get-active self))

(define-method glim-gadget-value ((self <glim-toggle-button>) value)
  (gtk-toggle-button-set-active self value))

; <glim-radio-box>
; <glim-check-box>


(provide "glim/pane/button")

