;;;
;;; glim/pane/label.scm - glim-label-pane, to be autoloaded by glim.pane
;;;
;;;  Copyright(C) 2002-2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: label.scm,v 1.4 2003/01/01 01:04:00 shirok Exp $
;;;

(select-module glim.pane)

;;---------------------------------------------------
;; <glim-label-pane>
;;

(define-class <glim-label-pane> (<glim-gtk-mixin> <glim-gadget> <gtk-label>)
  ((text  :allocation :virtual
          :init-keyword :text
          :slot-ref  gtk-label-get-text
          :slot-set! (lambda (o v) (gtk-label-set-text o (x->string v))))
   (%align :init-value '(0 0))          ; has to be before align and valign
   (align :allocation :virtual
          :init-keyword :align
          :slot-ref  (lambda (o) (car (ref o '%align)))
          :slot-set! (lambda (o v)
                       (set! (car (ref o '%align))
                             (case v
                               ((left) 0)
                               ((right) 1)
                               (else (error "bad value for align" v))))
                       (apply gtk-misc-set-alignment o (ref o '%align))))
   (valign :allocation :virtual
           :init-keyword :valign
           :slot-ref  (lambda (o) (cadr (ref o '%align)))
           :slot-set! (lambda (o v)
                        (set! (cadr (ref o '%align))
                              (case v
                                ((top) 0)
                                ((bottom) 1)
                                (else (error "bad value for valign" v))))
                        (apply gtk-misc-set-alignment o (ref o '%align))))
   ))

(define-method initialize ((self <glim-label-pane>) initargs)
  (next-method))

(provide "glim/pane/label")

