;;;
;;; glim/pane/spin.scm - glim-spin, to be autoloaded by glim.pane
;;;
;;;  Copyright(C) 2002-2003 by Shiro Kawai (shiro@acm.org)
;;;
;;;  Permission to use, copy, modify, distribute this software and
;;;  accompanying documentation for any purpose is hereby granted,
;;;  provided that existing copyright notices are retained in all
;;;  copies and that this notice is included verbatim in all
;;;  distributions.
;;;  This software is provided as is, without express or implied
;;;  warranty.  In no circumstances the author(s) shall be liable
;;;  for any damages arising out of the use of this software.
;;;
;;;  $Id: spin.scm,v 1.4 2003/01/01 01:04:00 shirok Exp $
;;;

(select-module glim.pane)

;;---------------------------------------------------
;; <glim-spin-button>
;;   Spin button.

(define-class <glim-spin-button> (<glim-gtk-mixin>
                                  <glim-value-gadget>
                                  <gtk-spin-button>)
  ((min       :init-keyword :min    :init-value 0)
   (max       :init-keyword :max    :init-value 1)
   (step      :init-keyword :step   :init-value 0.1)
   (digits    :allocation :virtual
              :init-keyword :digits :init-value 3
              :slot-ref  (lambda (o)
                           (gtk-spin-button-get-digits o))
              :slot-set! (lambda (o v)
                           (gtk-spin-button-set-digits o (x->integer v))))
   ))

(define-method initialize ((self <glim-spin-button>) initargs)
  (let-keywords* initargs ((min  0)
                           (max  1)
                           (step 0.1))
    (let ((adj  (gtk-adjustment-new min min max step step 0.1)))
      (gtk-spin-button-set-adjustment self adj)
      (next-method)
      (g-signal-connect self "value-changed"
                        (lambda (w)
                          (glim-value-changed-callback self
                                                       (glim-gadget-value self))))
      )))

(define-method glim-gadget-value ((self <glim-spin-button>))
  (gtk-spin-button-get-value self))

(define-method (setter glim-gadget-value) ((self <glim-spin-button>) value)
  (gtk-spin-button-set-value self value))

(provide "glim/pane/spin")
